/*-- object toolbar verwijderen (knop import quotation) --*/
DEFINE BUFFER b-sp-model-3-object FOR sp-model-3-object.
DEFINE BUFFER b-sp-model-3-link FOR sp-model-3-link.

/*-- slechts eenmaal uitvoeren --*/
IF CAN-FIND(FIRST sp-control WHERE 
                  sp-control.controlkode EQ 'ca-patch-05-remove-import-btn'
               OR sp-control.controlkode EQ 'ca-after-05-remove-import-btn' )
THEN RETURN.

DO TRANSACTION:
   /*-- u_shipment_item_tariff --*/
   FIND b-sp-model-3-object WHERE TRUE 
    AND b-sp-model-3-object.applicatiekode = 'ca'
    AND b-sp-model-3-object.modelkode = 'u_shipment_item_tariff'
    AND b-sp-model-3-object.objectkode = 'p-toolbar-panel'
    EXCLUSIVE-LOCK NO-ERROR.
    IF AVAILABLE b-sp-model-3-object
    THEN DELETE b-sp-model-3-object.
    
   FIND b-sp-model-3-link WHERE TRUE 
    AND b-sp-model-3-link.applicatiekode = 'ca'
    AND b-sp-model-3-link.modelkode = 'U_SHIPMENT_ITEM_TARIFF'
    AND b-sp-model-3-link.link_source = 'p-toolbar-panel'
    AND b-sp-model-3-link.link_type = 'spToolbar'
    AND b-sp-model-3-link.link_target = 'v-viewer'
    AND b-sp-model-3-link.linknaam = ''
    AND b-sp-model-3-link.linkuitleg = ''
    EXCLUSIVE-LOCK NO-ERROR.
    IF AVAILABLE b-sp-model-3-link
    THEN DELETE b-sp-model-3-link.
   
   /*-- i_shipment_item_tariff --*/
   FIND b-sp-model-3-object WHERE TRUE 
    AND b-sp-model-3-object.applicatiekode = 'ca'
    AND b-sp-model-3-object.modelkode = 'i_shipment_item_tariff'
    AND b-sp-model-3-object.objectkode = 'p-toolbar-panel'
    EXCLUSIVE-LOCK NO-ERROR.
    IF AVAILABLE b-sp-model-3-object
    THEN DELETE b-sp-model-3-object.
   FIND b-sp-model-3-link WHERE TRUE 
    AND b-sp-model-3-link.applicatiekode = 'ca'
    AND b-sp-model-3-link.modelkode = 'i_shipment_item_tariff'
    AND b-sp-model-3-link.link_source = 'p-toolbar-panel'
    AND b-sp-model-3-link.link_type = 'spToolbar'
    AND b-sp-model-3-link.link_target = 'v-viewer'
    AND b-sp-model-3-link.linknaam = ''
    AND b-sp-model-3-link.linkuitleg = ''
    EXCLUSIVE-LOCK NO-ERROR.
    IF AVAILABLE b-sp-model-3-link
    THEN DELETE b-sp-model-3-link.

   /*-- registreren voor toekomstige runs --*/
   CREATE sp-control.
   ASSIGN sp-control.controlkode = 'ca-patch-05-remove-import-btn'
          sp-control.lijst       = 'uitgevoerd op ' + STRING(TODAY,'99-99-9999') + ' ' + STRING(TIME,'HH:MM:SS')
          sp-control.uitleg      = 'Model3 bijwerken: knop import quotation in tariff schermen verwijderen'.
END. /*transaction*/
