/******************************************************************************
   ter voorbereiding van ca-post-02-replace-chargecode.p
*******************************************************************************/

/*--indien al een keer uitgevoerd, dan overslaan --*/
IF CAN-FIND(FIRST sp-control WHERE
                  sp-control.controlkode EQ THIS-PROCEDURE:FILE-NAME )
THEN RETURN.

DEF VAR cProgram  AS CHAR NO-UNDO.
DEF VAR cAction   AS CHAR NO-UNDO.
DEF VAR cTable    AS CHAR NO-UNDO.
DEF VAR iTotal    AS INT  NO-UNDO.
DEF VAR iDone     AS INT  NO-UNDO.
DEF VAR iModulo   AS INT  NO-UNDO.
DEF VAR cDumpFile AS CHAR   NO-UNDO.
DEF STREAM dumpFile.
DEF STREAM showInfo.

ASSIGN cProgram  =  THIS-PROCEDURE:FILE-NAME
       cAction   = ''
       iModulo   =  100  /* om de 100 records info tonen */
       cDumpFile = SESSION:TEMP-DIRECTORY + 'ca-u_surcharge-chargecode.d'.

FORM 'Program  :' AT 1 cProgram   NO-LABEL  FORMAT 'x(50)'    AT 12  SKIP
     'Action   :' AT 1 cAction    NO-LABEL  FORMAT 'x(50)'    AT 12  SKIP
     'Table    :' AT 1 cTable     NO-LABEL  FORMAT 'x(50)'    AT 12  SKIP
     'Total    :' AT 1 iTotal     NO-LABEL  FORMAT '9999999'  AT 12  SKIP
     'Done     :' AT 1 iDone      NO-LABEL  FORMAT '9999999'  AT 12  SKIP   
     'Dump File:' AT 1 cDumpFile  NO-LABEL  FORMAT 'x(50)'    AT 12  SKIP
     WITH FRAME a.

&GLOBAL-DEFINE STREAM showInfo mydisplay cProgram cAction cTable iTotal iDone cDumpFile WITH FRAME a

/*****************************************************************************************************
   EVEN TELLEN, 
*****************************************************************************************************/
cAction = 'Counting..' .
cTable = 'CA-U_SURCHARGES'. 
DISPLAY {&mydisplay}.
FOR EACH ca-u_surcharges NO-LOCK:
   iTotal = iTotal + 1.
   IF iTotal MODULO iModulo EQ 0 
   THEN DISPLAY {&mydisplay}.
END.

/*****************************************************************************************************
 MAIN BLOCK
 *****************************************************************************************************/
ASSIGN cTable  = 'ca-u_shipment_item_tariff'
       cAction = 'Copy chargecode to costcode'.
DISPLAY {&mydisplay}.

OUTPUT STREAM dumpFile TO VALUE(cDumpFile).
   FOR EACH ca-u_surcharge EXCLUSIVE-LOCK TRANSACTION:
      ASSIGN iDone = iDone + 1.
      EXPORT STREAM dumpFile  DELIMITER ';' ca-u_surcharge. 
      IF iDone MODULO iModulo EQ 0 
      THEN DISPLAY {&mydisplay}.
   END. /*each */
OUTPUT STREAM dumpFile CLOSE.

/*****************************************************************************************************
     registreren voor toekomstige runs dat deze script al is uitgevoerd en kan worden overgeslagen
*****************************************************************************************************/
ASSIGN cTable  = ''
       cAction = 'Done...' .
DISPLAY {&mydisplay}.

DISABLE TRIGGERS FOR LOAD of sp-control.

DO TRANSACTION:
   CREATE sp-control.
   ASSIGN sp-control.controlkode = THIS-PROCEDURE:FILE-NAME
          sp-control.lijst       = 'uitgevoerd op ' + STRING(TODAY,'99-99-9999') + ' ' + STRING(TIME,'HH:MM:SS')
          sp-control.uitleg      = 'Copy chargecode to costcode'
          sp-control.lijst-2     = cDumpFile.
END. /*transaction*/
                    

   
