&ANALYZE-SUSPEND _VERSION-NUMBER UIB_v9r12 GUI
&ANALYZE-RESUME
&Scoped-define WINDOW-NAME C-Win
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _DEFINITIONS C-Win 
/*------------------------------------------------------------------------

  File: 

  Description: 

  Input Parameters:
      <none>

  Output Parameters:
      <none>

  Author: 

  Created: 

------------------------------------------------------------------------*/
/*          This .W file was created with the Progress AppBuilder.      */
/*----------------------------------------------------------------------*/
 
/* Create an unnamed pool to store all the widgets created 
     by this procedure. This is a good default which assures
     that this procedure's triggers and internal procedures 
     will execute in this procedure's storage, and that proper
     cleanup will occur on deletion of the procedure. */

CREATE WIDGET-POOL.

/* ***************************  Definitions  ************************** */

/* Parameters Definitions ---                                           */

/* Local Variable Definitions ---                                       */
DEF TEMP-TABLE tt-dict NO-UNDO
   FIELD UID              AS ROWID
   FIELD db               AS CHAR
   FIELD dict_file        AS CHAR
   FIELD dict_file-rowid  AS ROWID
   FIELD dict_field       AS CHAR
   FIELD dict_field-rowid AS ROWID
   FIELD index-rowid      AS ROWID
   FIELD prime-index      AS RECID
   FIELD dict_format      AS CHAR
   FIELD searchVal        AS CHAR
   FIELD ind_file         AS LOG
   FIELD ind_field        AS LOG
   FIELD ind_index        AS LOG
   INDEX idx-pu IS PRIMARY UNIQUE
      UID ASCENDING
   INDEX idx-search IS WORD-INDEX
      searchVal ASCENDING
   .
DEF TEMP-TABLE tt-property NO-UNDO
   FIELD propertyUID   AS ROWID 
   FIELD propertyName  AS CHAR
   FIELD propertyValue AS CHAR
   .

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&ANALYZE-SUSPEND _UIB-PREPROCESSOR-BLOCK 

/* ********************  Preprocessor Definitions  ******************** */

&Scoped-define PROCEDURE-TYPE Window
&Scoped-define DB-AWARE no

/* Name of designated FRAME-NAME and/or first browse and/or first query */
&Scoped-define FRAME-NAME DEFAULT-FRAME
&Scoped-define BROWSE-NAME br-dict

/* Internal Tables (found by Frame, Query & Browse Queries)             */
&Scoped-define INTERNAL-TABLES tt-dict tt-property

/* Definitions for BROWSE br-dict                                       */
&Scoped-define FIELDS-IN-QUERY-br-dict /* REPLACE(tt-dict.des, '.', ' ') */ /* db */ dict_file dict_field dict_format   
&Scoped-define ENABLED-FIELDS-IN-QUERY-br-dict   
&Scoped-define SELF-NAME br-dict
&Scoped-define OPEN-QUERY-br-dict    DEF VAR iNumRec AS INT    NO-UNDO.    DEF VAR hQuery  AS HANDLE NO-UNDO.    DEF VAR hWin    AS HANDLE NO-UNDO.     hWin = FRAME {&FRAME-NAME}:WINDOW.     IF fil-search EQ ''    THEN fil-search = '*'.     OPEN QUERY {&SELF-NAME} FOR EACH tt-dict WHERE                                     tt-dict.searchVal MATCHES fil-search                                 AND (IF tt-dict.ind_file  THEN tg-ShowTable  ELSE YES)                                 AND (IF tt-dict.ind_field THEN tg-ShowFields ELSE YES)                                 AND (IF tt-dict.ind_index THEN tg-ShowIndex  ELSE YES)                                     NO-LOCK                                     BY tt-dict.searchVal.     ASSIGN       hQuery  = BROWSE br-dict:QUERY.       iNumRec = hQuery:NUM-RESULTS.    CASE iNumRec:       WHEN 0 THEN hWin:TITLE = 'Dictonary - No entities found'.       WHEN 1 THEN hWin:TITLE = 'Dictonary - ' + STRING(iNumRec) + ' entity found'.       OTHERWISE   hWin:TITLE = 'Dictonary - ' + STRING(iNumRec) + ' entities found'.    END CASE.
&Scoped-define TABLES-IN-QUERY-br-dict tt-dict
&Scoped-define FIRST-TABLE-IN-QUERY-br-dict tt-dict


/* Definitions for BROWSE br-properties                                 */
&Scoped-define FIELDS-IN-QUERY-br-properties propertyName propertyValue   
&Scoped-define ENABLED-FIELDS-IN-QUERY-br-properties   
&Scoped-define SELF-NAME br-properties
&Scoped-define QUERY-STRING-br-properties FOR EACH tt-property WHERE                                  tt-property.propertyUID EQ tt-dict.UID                                  BY tt-property.propertyName. /* IF BROWSE br-properties:NUM-SELECTED-ROWS GE 1 */ /* THEN BROWSE br-properties:DESELECT-ROWS().     */
&Scoped-define OPEN-QUERY-br-properties OPEN QUERY {&SELF-NAME} FOR EACH tt-property WHERE                                  tt-property.propertyUID EQ tt-dict.UID                                  BY tt-property.propertyName. /* IF BROWSE br-properties:NUM-SELECTED-ROWS GE 1 */ /* THEN BROWSE br-properties:DESELECT-ROWS().     */.
&Scoped-define TABLES-IN-QUERY-br-properties tt-property
&Scoped-define FIRST-TABLE-IN-QUERY-br-properties tt-property


/* Definitions for FRAME DEFAULT-FRAME                                  */
&Scoped-define OPEN-BROWSERS-IN-QUERY-DEFAULT-FRAME ~
    ~{&OPEN-QUERY-br-dict}

/* Standard List Definitions                                            */
&Scoped-Define ENABLED-OBJECTS tg-ShowTable fil-search tg-ShowFields ~
br-dict tg-ShowIndex sl-db br-properties 
&Scoped-Define DISPLAYED-OBJECTS tg-ShowTable fil-search tg-ShowFields ~
tg-ShowIndex sl-db 

/* Custom List Definitions                                              */
/* List-1,List-2,List-3,List-4,List-5,List-6                            */

/* _UIB-PREPROCESSOR-BLOCK-END */
&ANALYZE-RESUME


/* ************************  Function Prototypes ********************** */

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _FUNCTION-FORWARD AddProp C-Win 
FUNCTION AddProp RETURNS LOGICAL
  ( prUID   AS ROWID
  , phField AS HANDLE )  FORWARD.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _FUNCTION-FORWARD autoWrap C-Win 
FUNCTION autoWrap RETURNS CHARACTER
  ( pcString AS CHAR 
  , piWidth  AS INTEGER
  )  FORWARD.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _FUNCTION-FORWARD BufVal C-Win 
FUNCTION BufVal RETURNS CHARACTER
  ( phBuf   AS HANDLE
  , pcField AS CHAR )  FORWARD.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _FUNCTION-FORWARD empty C-Win 
FUNCTION empty RETURNS LOGICAL
  ( pcValue AS CHAR )  FORWARD.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _FUNCTION-FORWARD getIndexFields C-Win 
FUNCTION getIndexFields RETURNS CHARACTER
  ( prIdxRecId AS RECID )  FORWARD.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _FUNCTION-FORWARD NoNull C-Win 
FUNCTION NoNull RETURNS CHARACTER
  ( pcVal AS CHAR )  FORWARD.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


/* ***********************  Control Definitions  ********************** */

/* Define the widget handle for the window                              */
DEFINE VAR C-Win AS WIDGET-HANDLE NO-UNDO.

/* Definitions of the field level widgets                               */
DEFINE VARIABLE fil-search AS CHARACTER FORMAT "X(256)":U 
     VIEW-AS FILL-IN 
     SIZE 123 BY 1 NO-UNDO.

DEFINE VARIABLE sl-db AS CHARACTER 
     VIEW-AS SELECTION-LIST SINGLE SORT SCROLLBAR-VERTICAL 
     SIZE 24 BY 13.81 NO-UNDO.

DEFINE VARIABLE tg-ShowFields AS LOGICAL INITIAL yes 
     LABEL "Show field" 
     VIEW-AS TOGGLE-BOX
     SIZE 25 BY .81 NO-UNDO.

DEFINE VARIABLE tg-ShowIndex AS LOGICAL INITIAL yes 
     LABEL "Show index" 
     VIEW-AS TOGGLE-BOX
     SIZE 26 BY .81 NO-UNDO.

DEFINE VARIABLE tg-ShowTable AS LOGICAL INITIAL no 
     LABEL "Show Table" 
     VIEW-AS TOGGLE-BOX
     SIZE 26.2 BY .81 NO-UNDO.

/* Query definitions                                                    */
&ANALYZE-SUSPEND
DEFINE QUERY br-dict FOR 
      tt-dict SCROLLING.

DEFINE QUERY br-properties FOR 
      tt-property SCROLLING.
&ANALYZE-RESUME

/* Browse definitions                                                   */
DEFINE BROWSE br-dict
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _DISPLAY-FIELDS br-dict C-Win _FREEFORM
  QUERY br-dict DISPLAY
      /*       REPLACE(tt-dict.des, '.', '     ') FORMAT 'X(500)' LABEL '' */
      /*   db     FORMAT 'x(5)'   LABEL 'DB' */
      dict_file   FORMAT 'x(30)' LABEL 'Table'
      dict_field  FORMAT 'x(50)' LABEL 'Field' WIDTH 30
      dict_format FORMAT 'x(15)' LABEL 'Format'
/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME
    WITH NO-ROW-MARKERS SIZE 97.4 BY 13.91
         BGCOLOR 8 FGCOLOR 0 FONT 6
         TITLE BGCOLOR 8 FGCOLOR 0 "Fields" FIT-LAST-COLUMN.

DEFINE BROWSE br-properties
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _DISPLAY-FIELDS br-properties C-Win _FREEFORM
  QUERY br-properties DISPLAY
      propertyName  FORMAT 'x(30)'  LABEL 'Property' 
    propertyValue FORMAT 'x(200)' LABEL 'Value'
/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME
    WITH NO-ROW-MARKERS NO-COLUMN-SCROLLING NO-TAB-STOP SIZE 64.2 BY 12.95
         BGCOLOR 8 FGCOLOR 0 FONT 6
         TITLE BGCOLOR 8 FGCOLOR 0 "Properties" FIT-LAST-COLUMN.


/* ************************  Frame Definitions  *********************** */

DEFINE FRAME DEFAULT-FRAME
     tg-ShowTable AT ROW 1.19 COL 129
     fil-search AT ROW 1.57 COL 3.4 NO-LABEL
     tg-ShowFields AT ROW 2.05 COL 129
     br-dict AT ROW 2.81 COL 29.2
     tg-ShowIndex AT ROW 2.81 COL 129
     sl-db AT ROW 2.91 COL 3.4 NO-LABEL
     br-properties AT ROW 3.76 COL 128.8
    WITH 1 DOWN NO-BOX KEEP-TAB-ORDER OVERLAY 
         SIDE-LABELS NO-UNDERLINE THREE-D 
         AT COL 1 ROW 1
         SIZE 194.4 BY 16.05.


/* *********************** Procedure Settings ************************ */

&ANALYZE-SUSPEND _PROCEDURE-SETTINGS
/* Settings for THIS-PROCEDURE
   Type: Window
   Allow: Basic,Browse,DB-Fields,Window,Query
   Other Settings: COMPILE
 */
&ANALYZE-RESUME _END-PROCEDURE-SETTINGS

/* *************************  Create Window  ************************** */

&ANALYZE-SUSPEND _CREATE-WINDOW
IF SESSION:DISPLAY-TYPE = "GUI":U THEN
  CREATE WINDOW C-Win ASSIGN
         HIDDEN             = YES
         TITLE              = "Dictionary"
         HEIGHT             = 16.05
         WIDTH              = 194.4
         MAX-HEIGHT         = 100
         MAX-WIDTH          = 194.4
         VIRTUAL-HEIGHT     = 100
         VIRTUAL-WIDTH      = 194.4
         MAX-BUTTON         = no
         RESIZE             = yes
         SCROLL-BARS        = no
         STATUS-AREA        = no
         BGCOLOR            = ?
         FGCOLOR            = ?
         KEEP-FRAME-Z-ORDER = yes
         THREE-D            = yes
         MESSAGE-AREA       = no
         SENSITIVE          = yes.
ELSE {&WINDOW-NAME} = CURRENT-WINDOW.

&IF '{&WINDOW-SYSTEM}' NE 'TTY' &THEN
IF NOT C-Win:LOAD-ICON("system/media/softpak-task.ico":U) THEN
    MESSAGE "Unable to load icon: system/media/softpak-task.ico"
            VIEW-AS ALERT-BOX WARNING BUTTONS OK.
&ENDIF
/* END WINDOW DEFINITION                                                */
&ANALYZE-RESUME



/* ***********  Runtime Attributes and AppBuilder Settings  *********** */

&ANALYZE-SUSPEND _RUN-TIME-ATTRIBUTES
/* SETTINGS FOR WINDOW C-Win
  VISIBLE,,RUN-PERSISTENT                                               */
/* SETTINGS FOR FRAME DEFAULT-FRAME
   FRAME-NAME                                                           */
/* BROWSE-TAB br-dict tg-ShowFields DEFAULT-FRAME */
/* BROWSE-TAB br-properties sl-db DEFAULT-FRAME */
ASSIGN 
       br-dict:COLUMN-RESIZABLE IN FRAME DEFAULT-FRAME       = TRUE
       br-dict:COLUMN-MOVABLE IN FRAME DEFAULT-FRAME         = TRUE.

ASSIGN 
       br-properties:COLUMN-RESIZABLE IN FRAME DEFAULT-FRAME       = TRUE
       br-properties:COLUMN-MOVABLE IN FRAME DEFAULT-FRAME         = TRUE.

/* SETTINGS FOR FILL-IN fil-search IN FRAME DEFAULT-FRAME
   ALIGN-L                                                              */
IF SESSION:DISPLAY-TYPE = "GUI":U AND VALID-HANDLE(C-Win)
THEN C-Win:HIDDEN = no.

/* _RUN-TIME-ATTRIBUTES-END */
&ANALYZE-RESUME


/* Setting information for Queries and Browse Widgets fields            */

&ANALYZE-SUSPEND _QUERY-BLOCK BROWSE br-dict
/* Query rebuild information for BROWSE br-dict
     _START_FREEFORM
   DEF VAR iNumRec AS INT    NO-UNDO.
   DEF VAR hQuery  AS HANDLE NO-UNDO.
   DEF VAR hWin    AS HANDLE NO-UNDO.

   hWin = FRAME {&FRAME-NAME}:WINDOW.

   IF fil-search EQ ''
   THEN fil-search = '*'.

   OPEN QUERY {&SELF-NAME} FOR EACH tt-dict WHERE
                                    tt-dict.searchVal MATCHES fil-search
                                AND (IF tt-dict.ind_file  THEN tg-ShowTable  ELSE YES)
                                AND (IF tt-dict.ind_field THEN tg-ShowFields ELSE YES)
                                AND (IF tt-dict.ind_index THEN tg-ShowIndex  ELSE YES)
                                    NO-LOCK
                                    BY tt-dict.searchVal.

   ASSIGN
      hQuery  = BROWSE br-dict:QUERY.
      iNumRec = hQuery:NUM-RESULTS.
   CASE iNumRec:
      WHEN 0 THEN hWin:TITLE = 'Dictonary - No entities found'.
      WHEN 1 THEN hWin:TITLE = 'Dictonary - ' + STRING(iNumRec) + ' entity found'.
      OTHERWISE   hWin:TITLE = 'Dictonary - ' + STRING(iNumRec) + ' entities found'.
   END CASE.
     _END_FREEFORM
     _Query            is OPENED
*/  /* BROWSE br-dict */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _QUERY-BLOCK BROWSE br-properties
/* Query rebuild information for BROWSE br-properties
     _START_FREEFORM
OPEN QUERY {&SELF-NAME} FOR EACH tt-property WHERE
                                 tt-property.propertyUID EQ tt-dict.UID
                                 BY tt-property.propertyName.
/* IF BROWSE br-properties:NUM-SELECTED-ROWS GE 1 */
/* THEN BROWSE br-properties:DESELECT-ROWS().     */
     _END_FREEFORM
     _Query            is NOT OPENED
*/  /* BROWSE br-properties */
&ANALYZE-RESUME

 



/* ************************  Control Triggers  ************************ */

&Scoped-define SELF-NAME C-Win
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL C-Win C-Win
ON END-ERROR OF C-Win /* Dictionary */
OR ENDKEY OF {&WINDOW-NAME} ANYWHERE DO:
  /* This case occurs when the user presses the "Esc" key.
     In a persistently run window, just ignore this.  If we did not, the
     application would exit. */
  IF THIS-PROCEDURE:PERSISTENT THEN RETURN NO-APPLY.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL C-Win C-Win
ON WINDOW-CLOSE OF C-Win /* Dictionary */
DO:
  /* This event will close the window and terminate the procedure.  */
  APPLY "CLOSE":U TO THIS-PROCEDURE.
  RETURN NO-APPLY.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL C-Win C-Win
ON WINDOW-RESIZED OF C-Win /* Dictionary */
DO:
  ASSIGN FRAME {&FRAME-NAME}:HEIGHT-PIXELS         = CURRENT-WINDOW:HEIGHT-PIXELS
         FRAME {&FRAME-NAME}:VIRTUAL-HEIGHT-PIXELS = FRAME {&FRAME-NAME}:HEIGHT-PIXELS
         br-dict            :HEIGHT-PIXELS         = FRAME {&FRAME-NAME}:HEIGHT-PIXELS - br-dict   :Y - 10 
         br-properties      :HEIGHT-PIXELS         = FRAME {&FRAME-NAME}:HEIGHT-PIXELS - br-properties:Y - 10
         .
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define BROWSE-NAME br-dict
&Scoped-define SELF-NAME br-dict
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL br-dict C-Win
ON VALUE-CHANGED OF br-dict IN FRAME DEFAULT-FRAME /* Fields */
DO:
   DEF VAR hBuf   AS HANDLE NO-UNDO.
   DEF VAR iField AS INT    NO-UNDO.
   DEF VAR cList  AS CHAR   NO-UNDO.
   
   EMPTY TEMP-TABLE tt-property.
   
   IF NOT AVAILABLE tt-dict 
   THEN RETURN.
   
   CASE TRUE:
      WHEN tt-dict.ind_file THEN DO:
         CREATE BUFFER hBuf FOR TABLE sl-db:SCREEN-VALUE + '._file'.
         hBuf:FIND-BY-ROWID(tt-dict.dict_file-rowid,NO-LOCK).
         DO iField = 1 TO hBuf:NUM-FIELDS:
            AddProp(tt-dict.UID,hBuf:BUFFER-FIELD(iField)).
         END.
         DELETE OBJECT hBuf.
      END.

      WHEN tt-dict.ind_field THEN DO:
         CREATE BUFFER hBuf FOR TABLE sl-db:SCREEN-VALUE + '._field'.
         hBuf:FIND-BY-ROWID(tt-dict.dict_field-rowid,NO-LOCK).
         DO iField = 1 TO hBuf:NUM-FIELDS:
            AddProp(tt-dict.UID,hBuf:BUFFER-FIELD(iField)).
         END.
         DELETE OBJECT hBuf.
      END.
      
      WHEN tt-dict.ind_index THEN DO:
         CREATE BUFFER hBuf FOR TABLE sl-db:SCREEN-VALUE + '._index'.
         hBuf:FIND-BY-ROWID(tt-dict.index-rowid,NO-LOCK).
         AddProp(tt-dict.UID,hBuf:BUFFER-FIELD('_desc')).
         
         IF tt-dict.prime-index EQ hBuf:RECID
         THEN DO:
            CREATE 
               tt-property.
            ASSIGN 
               tt-property.propertyUID   = tt-dict.UID
               tt-property.propertyName  = ''
               tt-property.propertyValue = 'Primary'.
         END.
         
         IF BufVal(hBuf,'_unique') EQ 'YES' 
         THEN DO:
            CREATE 
               tt-property.
            ASSIGN 
               tt-property.propertyUID   = tt-dict.UID
               tt-property.propertyName  = ''
               tt-property.propertyValue = 'Unique'.
         END.
         IF BufVal(hBuf,'_active') EQ 'YES' 
         THEN DO:
            CREATE 
               tt-property.
            ASSIGN 
               tt-property.propertyUID   = tt-dict.UID
               tt-property.propertyName  = ''
               tt-property.propertyValue = 'Active'.
         END.   
         
         /*-- index fields --*/
         cList = getIndexFields(hBuf:RECID).
         DO iField = 1 TO NUM-ENTRIES(cList):
            CREATE 
               tt-property.
            ASSIGN 
               tt-property.propertyUID  = tt-dict.UID.
            ASSIGN
               tt-property.propertyName  = STRING(iField,'99: ') 
                                         + ENTRY(1,ENTRY(iField,cList),CHR(1))
               tt-property.propertyValue = ENTRY(2,ENTRY(iField,cList),CHR(1)).
         END. /*each index-fields of index*/
         DELETE OBJECT hBuf.
      END.

   END CASE.

   {&OPEN-QUERY-BR-PROPERTIES}
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME fil-search
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL fil-search C-Win
ON F12 OF fil-search IN FRAME DEFAULT-FRAME
DO:
  IF SELF:SENSITIVE 
  THEN APPLY 'U1' TO SELF.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL fil-search C-Win
ON RETURN OF fil-search IN FRAME DEFAULT-FRAME
DO:
  IF SELF:SENSITIVE 
  THEN APPLY 'U1' TO SELF.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL fil-search C-Win
ON U1 OF fil-search IN FRAME DEFAULT-FRAME
DO:
  IF EMPTY(SELF:SCREEN-VALUE)  
     OR SELF:SCREEN-VALUE EQ '*'
  THEN ASSIGN SELF:SCREEN-VALUE = '*'.
/*   ELSE ASSIGN SELF:SCREEN-VALUE = '*'                    */
/*                          + TRIM( SELF:SCREEN-VALUE, '*') */
/*                          + '*'.                   */
  
  /*-- punten worden door matches anders geinterperteerd --*/
  ASSIGN fil-search = REPLACE( SELF:SCREEN-VALUE, '.', CHR(1) ).
  
  {&OPEN-QUERY-br-dict}
  
  APPLY 'value-changed' TO br-dict.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME sl-db
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL sl-db C-Win
ON U1 OF sl-db IN FRAME DEFAULT-FRAME
DO:
   DEF VAR iDb AS INT    NO-UNDO.
   
   DO iDb = 1 TO NUM-DBS:
      SELF:ADD-LAST(LDBNAME( iDb )).
   END.
   
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL sl-db C-Win
ON VALUE-CHANGED OF sl-db IN FRAME DEFAULT-FRAME
DO:
   DEFINE VARIABLE cList     AS CHARACTER NO-UNDO.
   DEFINE VARIABLE hBfField  AS HANDLE    NO-UNDO.
   DEFINE VARIABLE hBfFile   AS HANDLE    NO-UNDO.
   DEFINE VARIABLE hBfIdx    AS HANDLE    NO-UNDO.
   DEFINE VARIABLE hField    AS HANDLE    NO-UNDO.
   DEFINE VARIABLE hQryField AS HANDLE    NO-UNDO.
   DEFINE VARIABLE hQryFile  AS HANDLE    NO-UNDO.
   DEFINE VARIABLE hQryIdx   AS HANDLE    NO-UNDO.
   DEFINE VARIABLE iField    AS INTEGER   NO-UNDO.
   DEFINE VARIABLE iNumFlds  AS INTEGER   NO-UNDO.
   DEFINE BUFFER ttTable FOR tt-dict.
   
   /* EMPTY TEMP-TABLE tt-dict. */
   IF CAN-FIND(FIRST tt-dict WHERE tt-dict.db EQ SELF:SCREEN-VALUE) THEN
      RETURN.
   
   IF EMPTY(SELF:SCREEN-VALUE) THEN 
      RETURN.
   
   SESSION:SET-WAIT-STATE( 'GENERAL' ).
   
   /*-- dyn objecten aanmaken en klaarzetten--*/
   CREATE BUFFER hBfFile   FOR TABLE SELF:SCREEN-VALUE + '._file'.
   CREATE BUFFER hBfField  FOR TABLE SELF:SCREEN-VALUE + '._field'.
   CREATE BUFFER hBfIdx    FOR TABLE SELF:SCREEN-VALUE + '._index'.
   
   CREATE QUERY hQryFile.   hQryFile  :SET-BUFFERS(hBfFile).
   CREATE QUERY hQryField.  hQryField :SET-BUFFERS(hBfField).
   CREATE QUERY hQryIdx.    hQryIdx   :SET-BUFFERS(hBfIdx).
           
   /*-- query's aanmaken en openen --*/
   hQryFile:QUERY-PREPARE('FOR EACH _file WHERE _file._Hidden      EQ NO'
                                        + ' AND _file._File-Number GT 0'
                                        + ' AND _file._File-Number LT 1000' ).   
   hQryFile:QUERY-OPEN().      
   hQryFile:GET-FIRST(NO-LOCK).
               
   /*-- query's doorlopen en opslaan in temp-table --*/                        
   DO WHILE hBfFile:AVAILABLE:
      /*-- tabellen --*/
      CREATE 
         ttTable.
      ASSIGN 
         ttTable.UID              = BUFFER ttTable:ROWID.
      ASSIGN                  
         ttTable.db               = SELF:SCREEN-VALUE
         ttTable.dict_file        = BufVal(hBfFile,'_file-name')
         ttTable.dict_file-rowid  = hBfFile:ROWID
         ttTable.dict_field       = ''
         ttTable.dict_field-rowid = ?
         ttTable.searchVal        = SELF:SCREEN-VALUE + CHR(1) + ttTable.dict_file
         ttTable.ind_file         = YES
         ttTable.ind_field        = NO
         ttTable.ind_index        = NO
         iNumFlds                 = 0.
                 
      /*-- velden --*/
      hQryField:QUERY-PREPARE(SUBSTITUTE('FOR EACH _field WHERE _field._File-recid EQ &1 '
                                                     + 'AND NOT _field._Field-name BEGINS "_"'
                                        ,hBfFile:RECID)).
      hQryField:QUERY-OPEN().      
      hQryField:GET-FIRST(NO-LOCK).
   
      DO WHILE hBfField:AVAILABLE:
         iNumFlds = iNumFlds + 1.
         CREATE 
            tt-dict.
         ASSIGN 
            tt-dict.UID              = BUFFER tt-dict:ROWID.
         ASSIGN                      
            tt-dict.db               = SELF:SCREEN-VALUE
            tt-dict.dict_file        = BufVal(hBfFile ,'_file-name')
            tt-dict.dict_file-rowid  = hBfFile:ROWID
            tt-dict.dict_field       = BufVal(hBfField,'_field-name')
            tt-dict.dict_field-rowid = hBfField:ROWID
            tt-dict.dict_format      = BufVal(hBfField,'_format')
            tt-dict.searchVal        = SELF:SCREEN-VALUE + CHR(1) + tt-dict.dict_file + CHR(1) + tt-dict.dict_field
            tt-dict.ind_file         = NO
            tt-dict.ind_field        = YES
            tt-dict.ind_index        = NO.
         hQryField:GET-NEXT(NO-LOCK). 
         PROCESS EVENTS.                           
      END. /*each field of file*/
      hQryField:QUERY-CLOSE().
      
      ttTable.dict_field = STRING(iNumFlds).
      
      /*-- indexen --*/
      hQryIdx:QUERY-PREPARE(SUBSTITUTE('FOR EACH _index WHERE _index._file-recid EQ &1',hBfFile:RECID)).
      hQryIdx:QUERY-OPEN().
      hQryIdx:GET-FIRST(NO-LOCK).
      
      DO WHILE hBfIdx:AVAILABLE:
         CREATE 
            tt-dict.
         ASSIGN
            tt-dict.UID              = BUFFER tt-dict:ROWID.
         ASSIGN                      
            tt-dict.db               = SELF:SCREEN-VALUE
            tt-dict.dict_file        = BufVal(hBfFile,'_file-name')
            tt-dict.dict_file-rowid  = hBfFile:ROWID
            hField                   = hBfFile:BUFFER-FIELD('_prime-index')
            tt-dict.dict_field       = SUBSTITUTE('idx &2&3&4 : &1'
                                                 ,BufVal(hBfIdx,'_index-name')
                                                 ,(IF hField:BUFFER-VALUE EQ hBfIdx:RECID THEN 'P' ELSE '_')
                                                 ,(IF bufVal(hBfIdx,'_unique') EQ 'YES'   THEN 'U' ELSE '_')
                                                 ,(IF bufVal(hBfIdx,'_active') EQ 'YES'   THEN 'A' ELSE '_') )
            tt-dict.dict_field-rowid = hBfField:ROWID
            tt-dict.index-rowid      = hBfIdx  :ROWID
            hField                   = hBfFile :BUFFER-FIELD('_prime-index')
            tt-dict.prime-index      = hField :BUFFER-VALUE
            tt-dict.ind_file         = NO   
            tt-dict.ind_field        = NO
            tt-dict.ind_index        = YES 
            tt-dict.searchVal        = SELF:SCREEN-VALUE + CHR(1) + tt-dict.dict_file + CHR(1) + tt-dict.dict_field.
         /*-- ook kunnen zoeken welke indexen een bepaald veld gebruiken --*/
         cList = getIndexFields(hBfIdx:RECID).
         DO iField = 1 TO NUM-ENTRIES(cList):
            tt-dict.searchVal = tt-dict.searchVal + CHR(1) + ENTRY(iField,cList,CHR(1)).
         END. /*cList*/
               
         hQryIdx:GET-NEXT(NO-LOCK).
         PROCESS EVENTS.
      END. /*each index of file*/
      hQryIdx:QUERY-CLOSE().
      hQryFile:GET-NEXT(NO-LOCK).
      PROCESS EVENTS.
   END. /*each file*/
   hQryFile:QUERY-CLOSE().
    
   DELETE OBJECT hBfFile.   
   DELETE OBJECT hBfField.   
   DELETE OBJECT hBfIdx.
                            
   DELETE OBJECT hQryFile.   
   DELETE OBJECT hQryField.  
   DELETE OBJECT hQryIdx.
   
   SESSION:SET-WAIT-STATE( '' ).
 
   {&OPEN-QUERY-BR-DICT}
   
   APPLY 'VALUE-CHANGED' TO br-dict.
   
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME tg-ShowFields
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL tg-ShowFields C-Win
ON VALUE-CHANGED OF tg-ShowFields IN FRAME DEFAULT-FRAME /* Show field */
DO:
  ASSIGN tg-ShowFields.
  APPLY 'U1' TO fil-search.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME tg-ShowIndex
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL tg-ShowIndex C-Win
ON VALUE-CHANGED OF tg-ShowIndex IN FRAME DEFAULT-FRAME /* Show index */
DO:
  ASSIGN tg-ShowIndex.
  APPLY 'U1' TO fil-search.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME tg-ShowTable
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL tg-ShowTable C-Win
ON VALUE-CHANGED OF tg-ShowTable IN FRAME DEFAULT-FRAME /* Show Table */
DO:
  ASSIGN tg-ShowTable.
  APPLY 'U1' TO fil-search.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&UNDEFINE SELF-NAME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _MAIN-BLOCK C-Win 


/* ***************************  Main Block  *************************** */

/* Set CURRENT-WINDOW: this will parent dialog-boxes and frames.        */
ASSIGN CURRENT-WINDOW                = {&WINDOW-NAME} 
       THIS-PROCEDURE:CURRENT-WINDOW = {&WINDOW-NAME}.

/* The CLOSE event can be used from inside or outside the procedure to  */
/* terminate it.                                                        */
ON CLOSE OF THIS-PROCEDURE 
   RUN disable_UI.

/* Best default for GUI applications is...                              */
PAUSE 0 BEFORE-HIDE.

/* Now enable the interface and wait for the exit condition.            */
/* (NOTE: handle ERROR and END-KEY so cleanup code will always fire.    */
MAIN-BLOCK:
DO ON ERROR   UNDO MAIN-BLOCK, LEAVE MAIN-BLOCK
   ON END-KEY UNDO MAIN-BLOCK, LEAVE MAIN-BLOCK:
  APPLY 'U1'            TO sl-db.
  APPLY 'VALUE-CHANGED' TO sl-db.
  RUN enable_UI.
  IF NOT THIS-PROCEDURE:PERSISTENT THEN
    WAIT-FOR CLOSE OF THIS-PROCEDURE.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


/* **********************  Internal Procedures  *********************** */

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE disable_UI C-Win  _DEFAULT-DISABLE
PROCEDURE disable_UI :
/*------------------------------------------------------------------------------
  Purpose:     DISABLE the User Interface
  Parameters:  <none>
  Notes:       Here we clean-up the user-interface by deleting
               dynamic widgets we have created and/or hide 
               frames.  This procedure is usually called when
               we are ready to "clean-up" after running.
------------------------------------------------------------------------------*/
  /* Delete the WINDOW we created */
  IF SESSION:DISPLAY-TYPE = "GUI":U AND VALID-HANDLE(C-Win)
  THEN DELETE WIDGET C-Win.
  IF THIS-PROCEDURE:PERSISTENT THEN DELETE PROCEDURE THIS-PROCEDURE.
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE enable_UI C-Win  _DEFAULT-ENABLE
PROCEDURE enable_UI :
/*------------------------------------------------------------------------------
  Purpose:     ENABLE the User Interface
  Parameters:  <none>
  Notes:       Here we display/view/enable the widgets in the
               user-interface.  In addition, OPEN all queries
               associated with each FRAME and BROWSE.
               These statements here are based on the "Other 
               Settings" section of the widget Property Sheets.
------------------------------------------------------------------------------*/
  DISPLAY tg-ShowTable fil-search tg-ShowFields tg-ShowIndex sl-db 
      WITH FRAME DEFAULT-FRAME IN WINDOW C-Win.
  ENABLE tg-ShowTable fil-search tg-ShowFields br-dict tg-ShowIndex sl-db 
         br-properties 
      WITH FRAME DEFAULT-FRAME IN WINDOW C-Win.
  {&OPEN-BROWSERS-IN-QUERY-DEFAULT-FRAME}
  VIEW C-Win.
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

/* ************************  Function Implementations ***************** */

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _FUNCTION AddProp C-Win 
FUNCTION AddProp RETURNS LOGICAL
  ( prUID   AS ROWID
  , phField AS HANDLE ) :
/*------------------------------------------------------------------------------
    Notes: alleen die properties tonen die ook daadwerkelijk gevuld zijn,
           lege zijn gewoon niet interesant. 
------------------------------------------------------------------------------*/
   DEF VAR iExt      AS INT    NO-UNDO.
   DEF VAR cPropName AS CHAR   NO-UNDO.
   DEF VAR iCreated  AS INT    NO-UNDO.
   
   cPropName = LEFT-TRIM(phField:NAME,'_').
   
   IF phField:EXTENT GT 0
   THEN ext: 
        DO iExt = 1 TO phField:EXTENT:
           IF EMPTY(STRING(phField:BUFFER-VALUE[iExt]))
           THEN NEXT ext.
           CREATE 
              tt-property.
           ASSIGN 
              iCreated                  = iCreated + 1
              tt-property.propertyUID   = prUID
              tt-property.propertyName  = cPropName + '[' + STRING(iExt) + ']'
              tt-property.propertyValue = NoNull(STRING(phField:BUFFER-VALUE[iExt])) .
        END.
   IF phField:EXTENT GT 0
   THEN RETURN iCreated GT 0.
       
   IF EMPTY(STRING(phField:BUFFER-VALUE))  
   THEN RETURN NO.
  
   CREATE 
      tt-property.
   ASSIGN 
      tt-property.propertyUID   = prUID
      tt-property.propertyName  = cPropName
      tt-property.propertyValue = NoNull(STRING(phField:BUFFER-VALUE)) .
   RETURN YES.

END FUNCTION.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _FUNCTION autoWrap C-Win 
FUNCTION autoWrap RETURNS CHARACTER
  ( pcString AS CHAR 
  , piWidth  AS INTEGER
  ) :
/*------------------------------------------------------------------------------
  Purpose:  ascii code 10 tussenvoegen om zo de tekst binnen de ingegeven breedte
            te houden.
    Notes:  iLength houdt de lengte bij van alle karakters toegevoegd, waarbij 
            command characters worden genegeerd zoals LF en RC (chr 10 en 13).
------------------------------------------------------------------------------*/
  DEF VAR cReturnValue AS CHAR   NO-UNDO.
  DEF VAR i            AS INT    NO-UNDO.
  DEF VAR iLength      AS INT    NO-UNDO.
  
  IF LENGTH(pcString) LE piWidth 
  THEN RETURN pcString.
  
  DO i = 1 TO LENGTH(pcString):
     ASSIGN iLength      = iLength + 1 WHEN SUBSTRING(pcString,i,1) GT CHR(14) 
            cReturnValue = cReturnValue 
                         + (IF iLength MODULO piWidth EQ 1
                            THEN CHR(10)
                            ELSE '' )
                         + SUBSTRING(pcString,i,1).
  END.
  
  RETURN cReturnValue.

END FUNCTION.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _FUNCTION BufVal C-Win 
FUNCTION BufVal RETURNS CHARACTER
  ( phBuf   AS HANDLE
  , pcField AS CHAR ) :
/*------------------------------------------------------------------------------
    Notes:  
------------------------------------------------------------------------------*/
   DEF VAR hField AS HANDLE NO-UNDO.
   DEF VAR cValue AS CHAR   NO-UNDO.
   DEF VAR iExt   AS INT    NO-UNDO.
   
   IF NOT VALID-HANDLE(phBuf) 
   THEN RETURN 'No valid buffer handle'.
   
   hField = phBuf:BUFFER-FIELD(pcField).
   
   IF NOT VALID-HANDLE(hField) 
   THEN RETURN SUBSTITUTE('Field &1 does not exist in buffer &2.',pcField,phBuf:NAME).
   
   IF hField:EXTENT GT 0
   THEN DO iExt = 1 TO hField:EXTENT:
      cValue = cValue + '|' + noNull(STRING(hField:BUFFER-VALUE[iExt])).
      IF iExt EQ hField:EXTENT 
      THEN RETURN cValue.
   END.
   
   RETURN noNull(STRING(hField:BUFFER-VALUE)).
   

END FUNCTION.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _FUNCTION empty C-Win 
FUNCTION empty RETURNS LOGICAL
  ( pcValue AS CHAR ) :
/*------------------------------------------------------------------------------
  Purpose:  
    Notes:  
------------------------------------------------------------------------------*/
   IF pcValue EQ ?
   THEN RETURN YES.
   
   IF pcValue EQ '?' 
   THEN RETURN YES.
   
   IF TRIM(pcValue) EQ '' 
   THEN RETURN YES.
   
   IF pcValue EQ '0'
   THEN RETURN YES.
   
   RETURN NO.
END FUNCTION.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _FUNCTION getIndexFields C-Win 
FUNCTION getIndexFields RETURNS CHARACTER
  ( prIdxRecId AS RECID ) :
/*------------------------------------------------------------------------------
    Notes:  
------------------------------------------------------------------------------*/
   DEF VAR cList        AS CHAR   NO-UNDO.
   DEF VAR hBufFld      AS HANDLE NO-UNDO.
   DEF VAR hBufIdxFld   AS HANDLE NO-UNDO.
   DEF VAR hQry         AS HANDLE NO-UNDO.
   
   /*-- index fields --*/
   DO WITH FRAME {&FRAME-NAME}:
      CREATE BUFFER hBufIdxFld FOR TABLE sl-db:SCREEN-VALUE + '._index-field'.
      CREATE BUFFER hBufFld    FOR TABLE sl-db:SCREEN-VALUE + '._field'.
      CREATE QUERY hQry.
   END. /*frame*/
   hQry:SET-BUFFERS(hBufIdxFld,hBufFld).
   hQry:QUERY-PREPARE(SUBSTITUTE( 'FOR EACH _index-field WHERE _index-field._index-recid EQ &1, '
                                +          'FIRST _field WHERE RECID(_field) EQ _index-field._Field-recid '
                                +                   'BY _index-field._Index-Seq.'
                                , prIdxRecId ) ).
   hQry:QUERY-OPEN().
   hQry:GET-FIRST(NO-LOCK).
   DO WHILE hBufIdxFld:AVAILABLE:
      cList = LEFT-TRIM(cList 
                       + ',' + BufVal(hBufFld,'_field-name') 
                       + CHR(1) 
                       + (IF BufVal(hBufIdxFld,'_ascending') EQ 'YES'
                          THEN 'Ascending'
                          ELSE 'Descendig')
                       ,',').
      hQry:GET-NEXT(NO-LOCK).
   END. /*each index-fields of index*/
   hQry:QUERY-CLOSE().
   DELETE OBJECT hBufFld.
   DELETE OBJECT hBufIdxFld.
   DELETE OBJECT hQry.
   
   RETURN cList.

END FUNCTION.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _FUNCTION NoNull C-Win 
FUNCTION NoNull RETURNS CHARACTER
  ( pcVal AS CHAR ) :
/*------------------------------------------------------------------------------
  Purpose:  No Unknown Value
    Notes:  
------------------------------------------------------------------------------*/
  IF pcVal EQ ? 
  THEN RETURN '<unknown value>'.
  
  RETURN pcVal.

END FUNCTION.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

